# SmartBody 1.01
# Smart entry body plugin for Movable Type
#
# Copyright 2002 Kalsey Consulting Group
# http://kalsey.com/
# Using this software signifies your acceptance of the license
# file that accompanies this software.
#
# Installation and usage instructions can be found at
# http://kalsey.com/blog/2002/07/smartbody_plugin.stm

use MT::Template::Context;
MT::Template::Context->add_tag(EntrySmartBody => sub { &EntrySmartBody; });
MT::Template::Context->add_container_tag(EntryIfExcerpt => sub { &EntryIfExcerpt; });

sub EntrySmartBody {
	my $ctx = shift;
    defined(my $entry = $ctx->stash('entry')) or return '';
	my $body = (!defined($entry->excerpt) || length($entry->excerpt)==0) ? $entry->text : $entry->excerpt;
    return '' unless !length($body)==0;
	return $body;
}

sub EntryIfExcerpt {
	my $ctx = shift;
    defined(my $entry = $ctx->stash('entry')) or return '';
	return '' if (!defined($entry->excerpt) || length($entry->excerpt)==0);
	my $builder = $ctx->stash('builder');
	my $tokens = $ctx->stash('tokens');
	defined(my $out = $builder->build($ctx,$tokens))
		or return '';
	return $out;
}